#ifndef __MEMORYMAP_H
#define __MEMORYMAP_H
#include <sys/types.h>
#include <fcntl.h>

#include "StringBasics.h"

class MemoryMap {
	int fd;
	off_t offset;
	size_t mapped_length;
	size_t total_length;
	size_t page_size;
	bool    useMemoryMapFlag;
public:
	void *data;
	MemoryMap();

	virtual ~MemoryMap();

	void debug_print();

	void constructor_clear();

	void destructor_clear();

	virtual int open(String file, int flags = O_RDONLY);
	virtual int create(String file, size_t size);

	int close();
	void test();
	size_t length() {return mapped_length;}

	char operator[] (unsigned int index) {
		return ((char *)data)[index];
	};
	int prefetch();     // force pages into RAM

	//
	// set or unset use of mmap() call in ::open().
	// This flag must be set before ::open() is called,
	// if it is called afterwards, it has no effect.
	//
	void useMemoryMap(bool flag=true) {useMemoryMapFlag = flag; }
};

#endif
