#ifndef __MATHBINNORMAL_H__
#define __MATHBINNORMAL_H__

#include "MathNormal.h"
#include "MathMiser.h"
#include "IntArray.h"

class DiscreteDataNormalEquations;

class DiscreteIntegrandFunc : public VectorFunc
   {
   public:
      DiscreteDataNormalEquations * normal;
      Vector y;
      double f1;

      DiscreteIntegrandFunc(DiscreteDataNormalEquations * n) : VectorFunc()
         { normal = n; }

      virtual double Evaluate(Vector & point);
   };

class DiscreteDataNormalEquations : public NormalEquations
   {
   public:
      DiscreteIntegrandFunc integrand;

      Matrix        hyperCube;
      MathMiser     miser;
      IntArray      upper;

      DiscreteDataNormalEquations();
      virtual ~DiscreteDataNormalEquations() { }

      virtual double Evaluate();
      virtual void   Prepare();
      virtual void   SelectPoint(Vector & point);
      virtual void   RetrievePoint(Vector & point);

   protected:
      void SortIntegrationRanges();
      bool isUnivariate(Matrix & correl);
   };

class DiscreteDataNormalSet : public NormalSet
   {
   public:
      DiscreteDataNormalSet();
      virtual ~DiscreteDataNormalSet() { }

      virtual int  CountParameters();

   protected:
      virtual void AllocateSets();
      virtual void GetStartingPoint(Vector & startPoint);
   };

#endif
